package com.rnsmileid

import org.json.JSONArray
import org.json.JSONException
import org.json.JSONObject
import java.util.*
import kotlin.collections.HashMap


class SIDUtil {
    companion object {
        @Throws(JSONException::class)
        fun convertJsonToMap(jsonObject: JSONObject): HashMap<Any, Any>? {
            val map: HashMap<Any, Any> = HashMap()
            val iterator: Iterator<String> = jsonObject.keys()
            while (iterator.hasNext()) {
                val key = iterator.next()
                val value: Any = jsonObject.get(key)
                if (value is JSONObject) {
                    convertJsonToMap(value as JSONObject)?.let { map.put(key, it) }
                } else if (value is JSONArray) {
                    convertJsonToArray(value as JSONArray)?.let { map.put(key, it) }
                } else if (value is Boolean) {
                    map.put(key, value)
                } else if (value is Int) {
                    map.put(key, value)
                } else if (value is Double) {
                    map.put(key, value)
                } else if (value is String) {
                    map.put(key, value)
                } else {
                    map.put(key, value.toString())
                }
            }
            return map
        }

        @Throws(JSONException::class)
        fun convertJsonToArray(jsonArray: JSONArray): List<Any>? {
            val array = mutableListOf<Any>()

            for (i in 0 until jsonArray.length()) {
                val value: Any = jsonArray.get(i)
                if (value is JSONObject) {
                    convertJsonToMap(value as JSONObject)?.let { array.add(it) }
                } else if (value is JSONArray) {
                    convertJsonToArray(value as JSONArray)?.let { array.add(it) }
                } else if (value is Boolean) {
                    array.add(value)
                } else if (value is Int) {
                    array.add(value)
                } else if (value is Double) {
                    array.add(value)
                } else if (value is String) {
                    array.add(value)
                } else {
                    array.add(value.toString())
                }
            }
            return array
        }

//        @Throws(JSONException::class)
//        fun convertMapToJson(readableMap: HashMap<Any, Any>?): JSONObject? {
//            val `object` = JSONObject()
//            val iterator = readableMap!!.keySetIterator()
//            while (iterator.hasNextKey()) {
//                val key = iterator.nextKey()
//                when (readableMap.getType(key)) {
//                    ReadableType.Null -> `object`.put(key, JSONObject.NULL)
//                    ReadableType.Boolean -> `object`.put(key, readableMap.getBoolean(key))
//                    ReadableType.Number -> `object`.put(key, readableMap.getDouble(key))
//                    ReadableType.String -> `object`.put(key, readableMap.getString(key))
//                    ReadableType.Map -> `object`.put(key, convertMapToJson(readableMap.getMap(key)))
//                    ReadableType.Array -> `object`.put(
//                        key,
//                        convertArrayToJson(readableMap.getArray(key))
//                    )
//                }
//            }
//            return `object`
//        }
//
//        @Throws(JSONException::class)
//        fun convertArrayToJson(readableArray: ReadableArray?): JSONArray? {
//            val array = JSONArray()
//            for (i in 0 until readableArray!!.size()) {
//                when (readableArray.getType(i)) {
//                    ReadableType.Null -> {
//                    }
//                    ReadableType.Boolean -> array.put(readableArray.getBoolean(i))
//                    ReadableType.Number -> array.put(readableArray.getDouble(i))
//                    ReadableType.String -> array.put(readableArray.getString(i))
//                    ReadableType.Map -> array.put(convertMapToJson(readableArray.getMap(i)))
//                    ReadableType.Array -> array.put(convertArrayToJson(readableArray.getArray(i)))
//                }
//            }
//            return array
//        }
    }
}
