import 'dart:async';
import 'dart:collection';

import 'package:flutter/services.dart';

class SmileFlutter {
  static const MethodChannel _channel = const MethodChannel('smile_flutter');
  final _uploadListenerEventChannel =
      const EventChannel('smile_id/upload_listener');
  final _completeListenerEventChannel =
      const EventChannel('smile_id/complete_listener');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<Map<dynamic, dynamic>?> captureSelfie(String tag) async {
    try {
      var result = await _channel.invokeMethod('captureSelfie', {"tag": tag});
      return result;
    } catch (e) {
      rethrow;
    }
  }

  static Future<Map<dynamic, dynamic>?> captureIDCard(String tag) async {
    try {
      var result = await _channel.invokeMethod('captureIDCard', {"tag": tag});
      return result;
    } catch (e) {
      rethrow;
    }
  }

  static Future<Map<dynamic, dynamic>?> captureSelfieAndIDCard(
      String tag) async {
    try {
      var result =
          await _channel.invokeMethod('captureSelfieAndIDCard', {"tag": tag});
      return result;
    } catch (e) {
      rethrow;
    }
  }

  static Future<Map<dynamic, dynamic>?> submitJob(
      String tag,
      int jobType,
      bool isProduction,
      String callBackUrl,
      Map<String, String>? partnerParams,
      Map<String, String>? idInfo,
      Map<String, String>? geoInfo) async {
    try {
      var result = await _channel.invokeMethod('submitJob', {
        "tag": tag,
        "jobType": jobType,
        "isProduction": isProduction,
        "callBackUrl": callBackUrl,
        "partnerParams": partnerParams,
        "idInfo": idInfo,
        "geoInfo": geoInfo
      });
      return result;
    } catch (e) {
      rethrow;
    }
  }
}
